/* Includes ------------------------------------------------------------------*/
#include <gpio_nand.h>
#include <stdio.h>
#include "Driver\DrvGPIO.h"   

/* Private typedef -----------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* д*/
void NAND_WRITE(uint8_t nfdata)
{
	NF_CEN_LOW;
	DrvSYS_Delay(NF_DELAY);
	NF_DATA_HB->DOUT = nfdata & 0xf0;
	NF_DATA_LB->DOUT = nfdata & 0x0f;
	DrvSYS_Delay(NF_DELAY);
	NF_WEN_LOW;
	DrvSYS_Delay(NF_DELAY);
	NF_WEN_HIGH;	//rising edge of WE
	DrvSYS_Delay(NF_DELAY);
	NF_CEN_HIGH;
}
/* */
uint8_t NAND_READ(void)
{	
	uint8_t nfdata;

	NF_CEN_LOW;
	DrvSYS_Delay(NF_DELAY);
	NF_REN_LOW;
	DrvSYS_Delay(NF_DELAY);
	nfdata =(NF_DATA_HB->PIN & 0xf0)+(NF_DATA_LB->PIN & 0x0f) ;	//Data is valid tREA after the falling edge of RE
	DrvSYS_Delay(NF_DELAY); 
	NF_REN_HIGH;
	DrvSYS_Delay(NF_DELAY);
	NF_CEN_HIGH;
	return nfdata;
}
void GPIO_NAND_test(void)
{ 
	int i,j=0;  
	int data;

	//NF_RB is defined as Input;
	DrvGPIO_Open(NF_RB, E_IO_INPUT);
	//NF_WPN NF_RST is defined as Output;
	DrvGPIO_Open(NF_WPN, E_IO_OUTPUT);
	DrvGPIO_Open(NF_RST, E_IO_OUTPUT);

	while(0)
	{
		//test for write
// 		NF_CLE_HIGH;
//		NAND_WRITE(0x55);
// 		NF_CLE_LOW ; 
// 		NF_ALE_HIGH;
//		NAND_WRITE(0xaa);
//		NF_ALE_LOW ;		 
/*		DrvGPIO_SetBit(NF_WPN);
		DrvGPIO_ClrBit(NF_WPN);
		DrvGPIO_SetBit(NF_RST);
		DrvGPIO_ClrBit(NF_RST);
*/
//		NF_WEN_HIGH;
//		NF_WEN_LOW ;
//		NF_CEN_HIGH;
//		NF_CEN_LOW ;
//		NF_REN_HIGH;
//		NF_REN_LOW ;
//		for(i=0;i<1000000;i++);
 	}
	while(1)
	{		
		//test for read
		data = 	NAND_READ();
//		data = 	((GPIOA->PIN & 0xfe00) >> 8 )+(GPIOC->PIN & 0x03);
		printf("Running %d Times : D7-D0:%1d%1d%1d%1d%1d%1d%1d%1dB : NF_RB:%1d\n\r",j++,
		(data>>7)&0x1,(data>>6)&0x1,(data>>5)&0x1,(data>>4)&0x1,
		(data>>3)&0x1,(data>>2)&0x1,(data>>1)&0x1,(data>>0)&0x1,DrvGPIO_GetBit(NF_RB)&0x1);
//		for(i=0;i<1000000;i++); //delay about 1 second
	}
}

void GPIO_NAND_Init(void)
{
	//NF_IO0-NF_IO7 is defined as bidirectional;
	DrvGPIO_Open(NF_IO0, E_IO_QUASI);
	DrvGPIO_Open(NF_IO1, E_IO_QUASI);
	DrvGPIO_Open(NF_IO2, E_IO_QUASI);
	DrvGPIO_Open(NF_IO3, E_IO_QUASI);
	DrvGPIO_Open(NF_IO4, E_IO_QUASI);
	DrvGPIO_Open(NF_IO5, E_IO_QUASI);
	DrvGPIO_Open(NF_IO6, E_IO_QUASI);
	DrvGPIO_Open(NF_IO7, E_IO_QUASI);
	//NF_WPN NF_RST NF_WEN NF_CEN NF_REN is defined as Output;
	DrvGPIO_Open(NF_WPN, E_IO_OUTPUT);
	DrvGPIO_Open(NF_RST, E_IO_OUTPUT); 
	DrvGPIO_Open(NF_WEN, E_IO_OUTPUT);
	DrvGPIO_Open(NF_CEN, E_IO_OUTPUT);
	DrvGPIO_Open(NF_REN, E_IO_OUTPUT);
	//NF_RB is defined as Input;
	DrvGPIO_Open(NF_RB, E_IO_INPUT);

	//NF_WPN NF_RST NF_WEN NF_CEN NF_REN is HIGH;
	DrvGPIO_SetBit(NF_WPN);
	DrvGPIO_SetBit(NF_RST);
	DrvGPIO_SetBit(NF_WEN);
	DrvGPIO_SetBit(NF_CEN);
	DrvGPIO_SetBit(NF_REN);
	//NF_ALE NF_CLE is LOW; 
	DrvGPIO_ClrBit(NF_CLE);
	DrvGPIO_ClrBit(NF_ALE);

//	GPIO_NAND_test();
} 

/**
  * @brief  Reads the NAND memory status using the Read status command 
  * @param  None
  * @retval :The status of the NAND memory. This parameter can be:
  *              - NAND_BUSY: when memory is busy
  *              - NAND_READY: when memory is ready for the next operation    
  *              - NAND_ERROR: when the previous operation gererates error     
  */
  
uint32_t GPIO_NAND_ReadStatus(void)
{
	uint32_t data = 0x00, status = NAND_BUSY;

	/* Read status operation ------------------------------------ */
	NF_CLE_HIGH; NAND_WRITE(NAND_CMD_STATUS);NF_CLE_LOW ; 
	data = NAND_READ();

	if((data & NAND_ERROR) == NAND_ERROR)
  	{
    	status = NAND_ERROR;
  	} 
  	else if((data & NAND_READY) == NAND_READY)
  	{
    	status = NAND_READY;
  	}
  	else
  	{
    	status = NAND_BUSY; 
  	}

	return (status);
} 

/**
  * @brief  Get the NAND operation status
  * @param  None
  * @retval :New status of the NAND operation. This parameter can be:
  *              - NAND_TIMEOUT_ERROR: when the previous operation generate 
  *                a Timeout error
  *              - NAND_READY: when memory is ready for the next operation    
  */
  
   
uint32_t GPIO_NAND_GetStatus(void)
{
	uint32_t timeout = 0x1000000, status = NAND_READY;

	status = GPIO_NAND_ReadStatus(); 

	/* Wait for a NAND operation to complete or a TIMEOUT to occur */
	while ((status != NAND_READY) &&( timeout != 0x00))
	{
		status = GPIO_NAND_ReadStatus();
		timeout --;      
	}

	if(timeout == 0x00)
	{          
		status =  NAND_TIMEOUT_ERROR;      
	} 

	/* Return the operation status */
	return (status);      
}
/**
  * @brief  This routine reset the NAND FLASH
  * @param  None
  * @retval :NAND_READY
  */

uint32_t GPIO_NAND_Reset(void)
{

	NF_CLE_HIGH; NAND_WRITE(NAND_CMD_RESET);NF_CLE_LOW;
	//Wait the NANDFLASH's RB# trun to high.
	while(DrvGPIO_GetBit(NF_RB) == 0);

  	return (NAND_READY);
}  
/**
  * @brief  Reads NAND memory's ID.
  * @param  NAND_ID: pointer to a NAND_IDTypeDef structure which will hold
  *                  the Manufacturer and Device ID.  
  * @retval : None
  */
uint32_t GPIO_NAND_ReadID(NAND_IDTypeDef* NAND_ID)
{

	/* Send Command to the command area */
	NF_CLE_HIGH; NAND_WRITE(NAND_CMD_READID);NF_CLE_LOW; 	
	/* Send Address to the address area */ 
	NF_ALE_HIGH; NAND_WRITE(NAND_CMD_IDADDR);NF_ALE_LOW;

   /* Sequence to read ID from NAND flash */	
	NAND_ID->Maker_ID   = NAND_READ();
	NAND_ID->Device_ID  = NAND_READ();
	NAND_ID->Third_ID   = NAND_READ();
	NAND_ID->Fourth_ID  = NAND_READ();
	NAND_ID->Fifth_ID   = NAND_READ(); 

	return (NAND_READY);
}
/**
  * @brief  This routine erase complete block from NAND FLASH
  * @param  PageAddress: Any address into block to be erased
  * @retval :New status of the NAND operation. This parameter can be:
  *              - NAND_TIMEOUT_ERROR: when the previous operation generate 
  *                a Timeout error
  *              - NAND_READY: when memory is ready for the next operation 
  */
  
uint32_t GPIO_NAND_EraseBlock(uint32_t BlockAddress)
{
	uint32_t data = 0xff, status = NAND_ERROR;
	uint32_t PageAddress;

	PageAddress = (BlockAddress << 6);
	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_ERASE0);NF_CLE_LOW;

	NF_ALE_HIGH;
	NAND_WRITE(ADDR_3rd_CYCLE(PageAddress));
	NAND_WRITE(ADDR_4th_CYCLE(PageAddress));
	NAND_WRITE(ADDR_5th_CYCLE(PageAddress));
	NF_ALE_LOW;

	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_ERASE1);NF_CLE_LOW;
	//Wait the NANDFLASH's RB# trun to high.
	while(DrvGPIO_GetBit(NF_RB) == 0);

	/* Read status operation ------------------------------------ */  
	GPIO_NAND_GetStatus();

	data = NAND_READ();
  
	if(!(data&0x1)) status = NAND_READY;

	return (status);
}

uint32_t GPIO_NAND_WritePage_test(uint8_t data, uint32_t PageAddress)
{
	uint32_t index = 0;
	uint32_t status = NAND_READY;
	uint32_t ret = 0xff;

    /* Page write command and address */
	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_WRITE0);NF_CLE_LOW;
	
 	NF_ALE_HIGH;
	NAND_WRITE(ADDR_1st_CYCLE(PageAddress));
	NAND_WRITE(ADDR_2nd_CYCLE(PageAddress));
	NAND_WRITE(ADDR_3rd_CYCLE(PageAddress));
	NAND_WRITE(ADDR_4th_CYCLE(PageAddress));
	NAND_WRITE(ADDR_5th_CYCLE(PageAddress));
	NF_ALE_LOW;
    
    /* Write data */
    for(; index < NAND_PAGE_SIZE; index++)
    {
		NAND_WRITE(data);
    }
    
	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_WRITE1);NF_CLE_LOW;

   //Wait the NANDFLASH's RB# trun to high.
	while(DrvGPIO_GetBit(NF_RB) == 0);
    
    /* Check status for successful operation */
    status = GPIO_NAND_GetStatus();
    
	ret = NAND_READ();
	printf("\n\r%s(%d): Running:  %s() GetStatus data = 0x%x\n\r",__FILE__,__LINE__,__FUNCTION__,ret);
	if(!(ret&0x1)) status = NAND_READY;

	return (status);
}

uint32_t GPIO_NAND_ReadPage_test(uint32_t PageAddress)
{
	uint32_t index = 0x00;
	uint32_t status = NAND_READY;
	uint32_t data = 0xff;

	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_READ1);NF_CLE_LOW;
	/* Page Read command and page address */

 	NF_ALE_HIGH;
	NAND_WRITE(ADDR_1st_CYCLE(PageAddress));
	NAND_WRITE(ADDR_2nd_CYCLE(PageAddress));
	NAND_WRITE(ADDR_3rd_CYCLE(PageAddress));
	NAND_WRITE(ADDR_4th_CYCLE(PageAddress));
	NAND_WRITE(ADDR_5th_CYCLE(PageAddress));
	NF_ALE_LOW;
	       
	NF_CLE_HIGH;NAND_WRITE(NAND_CMD_READ2);NF_CLE_LOW;

	//Wait the NANDFLASH's RB# trun to high.
	while(DrvGPIO_GetBit(NF_RB) == 0);
	    
	/* Get Data into Buffer */    
	for(; index < NAND_PAGE_SIZE; index++)
	{
		data= NAND_READ();
		if((index%16)== 0){printf("\n\r%08xh:",index);}
		printf(" %02x",data);
		if((index%16)==15){printf(" ;");}
	}
	printf("\n\r");
  	status = GPIO_NAND_GetStatus();
  	return (status);
}
