#include "time.h"

uint32_t uTimerEventNo[4];
volatile uint32_t u32Timer0Cnt=0, u32Timer1Cnt=0, u32Timer2Cnt=0, u32Timer3Cnt=0;

void TMR0_Callback(uint32_t u32Param)
{
	if (u32Param == 1)
    {
        printf(" Enter Timer callback #%dth, Current INT ticks is %d\n\r", ++u32Timer0Cnt, DrvTIMER_GetIntTicks(E_TMR0));
    }else
    {
        ++u32Timer0Cnt;
    }

		if(DrvGPIO_GetBit(KEY_ISP)==0)
		{
			printf("*** KEY_ISP DOWN!\n\r");
			DrvGPIO_SetBit(LED_RED);
		}
		else
		{   
		    printf("*** KEY_ISP UP!  \n\r");
			if((u32Timer0Cnt%2) == 0)
			{DrvGPIO_SetBit(LED_RED);}
			else
			{DrvGPIO_ClrBit(LED_RED);}
		}
}

void TMR0_Init(void)
{
    DrvTIMER_Init();
   	printf(" TIMER Sample Code \n");

    /* Set all the TIMER clock source are from 12MHz */
    DrvSYS_SelectIPClockSource(E_SYS_TMR0_CLKSRC, 0);

	/* Using TIMER0 in PERIODIC_MODE, 1000 ticks /sec */
	DrvTIMER_Open(E_TMR0, 1000, E_PERIODIC_MODE);  
                
	/* Install callback "TMR0_Callback" and trigger callback when Interrupt happen / 500 ticks */
	uTimerEventNo[0] = DrvTIMER_SetTimerEvent(E_TMR0, 500, (TIMER_CALLBACK)TMR0_Callback,1);
 			    
	/* Enable TIMER0 Intettupt */
	DrvTIMER_EnableInt(E_TMR0);	
	
	/* Start counting */
    u32Timer0Cnt = 0;
	DrvTIMER_Start(E_TMR0);
}

void TMR0_stop(void)
{
	/* Clear the Timer event */
	DrvTIMER_ClearTimerEvent(E_TMR0, uTimerEventNo[0]);

	/* Close TIMER0 */
	DrvTIMER_Close(E_TMR0);
}
