#include "uart.h"

#define RXBUFSIZE 256

/*---Using in UART Test -------------------*/
volatile uint8_t comRbuf[256];
volatile uint16_t comRbytes = 0;		/* Available receiving bytes */
volatile uint16_t comRhead 	= 0;
volatile uint16_t comRtail 	= 0;
volatile int32_t g_bWait 	= TRUE;
uint8_t u8SendData[12] ={0};

/*---------------------------------------------------------------------------------------------------------*/
/* UART0 Callback function                                                                           	   */
/*---------------------------------------------------------------------------------------------------------*/
void UART0_INT_HANDLE(uint32_t u32IntStatus)
{

 	uint8_t bInChar[1]={0xFF};

	if(u32IntStatus & DRVUART_RDAINT)
	{
		printf("\n\rInput:");
		
		/* Get all the input characters */
		while(UART1->ISR.RDA_IF==1) 
		{
			/* Get the character from UART1 Buffer */
			DrvUART_Read(UART_PORT0,bInChar,1);
			printf("%c ", bInChar[0]);
	
	if(bInChar[0] =='a' ){ DrvGPIO_SetBit(LED_RED);}
	if(bInChar[0] =='b' ){ DrvGPIO_ClrBit(LED_RED);}

			/* Check if buffer full */
			if(comRbytes < RXBUFSIZE)
			{
				/* Enqueue the character */
				comRbuf[comRtail] = bInChar[0];
				comRtail = (comRtail == (RXBUFSIZE-1)) ? 0 : (comRtail+1);
				comRbytes++;
			}			
		}
		printf("\n\rTransmission Test:");
	}
	else if(u32IntStatus & DRVUART_THREINT)
	{   
		   
        uint16_t tmp;
        tmp = comRtail;
		if(comRhead != tmp)
		{
			bInChar[0] = comRbuf[comRhead];
			DrvUART_Write(UART_PORT0,bInChar,1);
			comRhead = (comRhead == (RXBUFSIZE-1)) ? 0 : (comRhead+1);
			comRbytes--;
		}
		if(bInChar[0] == '0')	
		{	
			g_bWait = FALSE;
		}
	}
}

int UART0_init(void)
{
	STR_UART_T sParam;
   	
	/* Set UART0 Pin */
	DrvGPIO_InitFunction(E_FUNC_UART0);

	/* Select UART0 Clock Source From 12Mhz*/
	DrvSYS_SelectIPClockSource(E_SYS_UART_CLKSRC,0); 
	

	/* UART0 Setting */
    sParam.u32BaudRate 		= 1200;//115200;//9600;
    sParam.u8cDataBits 		= DRVUART_DATABITS_8;
    sParam.u8cStopBits 		= DRVUART_STOPBITS_1;
    sParam.u8cParity 		= DRVUART_PARITY_NONE;
    sParam.u8cRxTriggerLevel= DRVUART_FIFO_1BYTES;

	if(DrvUART_Open(UART_PORT0,&sParam) != E_SUCCESS)
	{
		printf("UART1 open failed\n");
		return FALSE;
	}
	/* Enable Interrupt and install the call back function */
	DrvUART_EnableInt(UART_PORT0, (DRVUART_RLSINT | DRVUART_RDAINT),UART0_INT_HANDLE);
		
	/* Disable Interrupt */
//	DrvUART_DisableInt(UART_PORT0,DRVUART_RLSINT | DRVUART_THREINT | DRVUART_RDAINT);

	return TRUE;
}

int fputc(int ch, FILE *f)
{
	uint8_t bInChar[1]={0xFF};
  /* Place your implementation of fputc here */
  /* e.g. write a character to the UART */

	bInChar[0]=(uint8_t)ch;
	DrvUART_Write(UART_PORT0,bInChar,1);

	return ch;
}

