#include "main.h"

//#define dprintf(...)
#define dprintf  printf

#define RSTN     		   		    E_GPC, 2 		/* PC2 = RSTN  */
#define T1     		   		    	E_GPC, 3 		/* PC3 = T1    */
#define MEN     		   		    E_GPC, 4 		/* PC4 = MEN   */

void SYS_init(void)
{
	/* SYSCLK =>12Mhz*/
	UNLOCKREG();
    SYSCLK->PWRCON.XTL12M_EN = 1;

 	 /* Waiting for 12M Xtal stalble */
    DrvSYS_Delay(5000);

	 /* Run 48Mhz */
    DrvSYS_Open(48000);

	DrvSYS_Delay(10000);
}

void NF_test(void)
{ 
	int i,j;
	NAND_IDTypeDef NF_ID_TMP;
	NAND_IDTypeDef *NF_ID = &NF_ID_TMP;

	GPIO_NAND_Init();
	GPIO_NAND_Reset();
	GPIO_NAND_ReadID(NF_ID);
	printf("NANDFLASH ID = 0x%02x %02x %02x %02x %02x\n\r",
	NF_ID->Maker_ID,NF_ID->Device_ID,NF_ID->Third_ID,NF_ID->Fourth_ID,NF_ID->Fifth_ID);

	GPIO_NAND_EraseBlock(0);
	GPIO_NAND_ReadPage_test(0);

	GPIO_NAND_WritePage_test(0xff, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);
	
	GPIO_NAND_EraseBlock(0);
	GPIO_NAND_WritePage_test(0x55, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);
		
	GPIO_NAND_EraseBlock(0);
	GPIO_NAND_WritePage_test(0xaa, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);
	
	GPIO_NAND_EraseBlock(0);
	GPIO_NAND_WritePage_test(0xcc, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);

	GPIO_NAND_EraseBlock(0);
	GPIO_NAND_WritePage_test(0x33, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);
			
	GPIO_NAND_WritePage_test(0x00, 0); // write a same data to every address
	GPIO_NAND_ReadPage_test(0);

#if 1
    // Erase 16 block 

	if(DrvGPIO_GetBit(T1) | DrvGPIO_GetBit(MEN))
	{
		for(i=0;i<0x100000;i++); 
		if(DrvGPIO_GetBit(T1) | DrvGPIO_GetBit(MEN))
		{
			DrvGPIO_ClrBit(RSTN);
			printf("The NANDFLASH is Eraseing now...\n\r");
			for(i=0;i<16;i++)
			{
				GPIO_NAND_EraseBlock(i);
				for(j=0;j<0x1000;j++);
				printf("*"); 
			}
		}
		printf("\n\rThe First 16 Block Eraseing is Finish!\n\r");
	}
#endif
	dprintf("%s(%d): Running:  %s()\n\r",__FILE__,__LINE__,__FUNCTION__);
}

int main(void)
{
	SYS_init();
//	UART0_init();

	/* Output a message on Hyperterminal using printf function */
	printf("\n\r\n\r\n\r\n\r");
	printf("*** 9G-NUC122 V1.00 Build by yuanxihua@21cn.com on ("__DATE__ " - " __TIME__ ")\n\r");
	printf("*** 9G-NUC122 V1.00 Rebooting ...\n\r\n\r");
//	GPIO_Init(); 	
//	TMR0_Init();

	while(1)
	{
		NF_test();
		dprintf("%s(%d): Running:  %s()\n\r",__FILE__,__LINE__,__FUNCTION__);
	}

	while(1)
	{
		if(DrvGPIO_GetBit(KEY_ISP)==0)
		{
			printf("*** KEY_ISP DOWN!\n\r");
//			DrvGPIO_ClrBit(LED_RED);
		}
		else
		{   
		    printf("*** KEY_ISP UP!  \n\r");
//			DrvGPIO_SetBit(LED_RED);
		}

	}
}
